@use "sass:map";
@use "../core/" as adm;

$name: 'adm-link';
$component-tokens: (
	#{$name}: (
		default: (
			background: transparent,
            background-hover: transparent,
            background-focus: transparent,
            background-active: transparent,
            background-visited: transparent,

            text: #000,
            text-hover: #000,
            text-focus: #000,
            text-active: #000,
            text-visited: #000,

            border: none,
			border-hover: adm.component-token($name, 'border'),
			border-focus: adm.component-token($name, 'border'),
			border-active: adm.component-token($name, 'border'),

			outline: none,
			outline-hover: none,
            outline-focus: 2px solid #000,
            outline-active: adm.component-token($name, 'outline-focus'),
			outline-offset: 2px,

            padding-x: 0,
            padding-y: 0,
            radius: 0,
            
            width: auto,
            height: auto,
            
            font-family: inherit,
            font-weight: 400,
            font-size: inherit,
            line-height: inherit,

            text-decoration: underline,
            text-decoration-hover: none,
            text-decoration-focus: adm.component-token($name, 'text-decoration-hover'),
            text-decoration-active: adm.component-token($name, 'text-decoration-hover'),
            underline-offset: 0.2em,  

            gap: 0,
		),
		image: (
			text-decoration: none,
		),
	),
) !default;

@mixin generate-component-markup() {
    a {
        position: relative;
        display: inline-flex;
        align-items: center;
        justify-content: center;
        box-sizing: border-box;
        cursor: pointer;

        background: adm.component-token($name, 'background');
        color: adm.component-token($name, 'text');
        border: adm.component-token($name, 'border');
        outline: adm.component-token($name, 'outline');
        outline-offset: adm.component-token($name, 'outline-offset');

        padding-left: adm.component-token($name, 'padding-x');
        padding-right: adm.component-token($name, 'padding-x');
        padding-top: adm.component-token($name, 'padding-y');
        padding-bottom: adm.component-token($name, 'padding-y');
            
        height: adm.component-token($name, 'height');
        width: adm.component-token($name, 'width');
        border-radius: adm.component-token($name, 'radius');

        font-family: adm.component-token($name, 'font-family');
        font-weight: adm.component-token($name, 'font-weight');
        font-size: adm.component-token($name, 'font-size');
        line-height: adm.component-token($name, 'line-height');

        text-decoration: adm.component-token($name, 'text-decoration');
        text-underline-offset: adm.component-token($name, 'underline-offset');
            
        gap: adm.component-token($name, 'gap');
        

        &:visited {
            background: adm.component-token($name, 'background-visited');
            color: adm.component-token($name, 'text-visited');
            border: adm.component-token($name, 'border-visited');
            text-decoration: adm.component-token($name, 'text-decoration-visited');
        }
        &:hover {
            background: adm.component-token($name, 'background-hover');
            color: adm.component-token($name, 'text-hover');
            border: adm.component-token($name, 'border-hover');
            outline: adm.component-token($name, 'outline-hove');
            text-decoration: adm.component-token($name, 'text-decoration-hover');
        }
        &:focus-visible {
            background: adm.component-token($name, 'background-focus');
            color: adm.component-token($name, 'text-focus');
            border: adm.component-token($name, 'border-focus');
            outline: adm.component-token($name, 'outline-focus');
            text-decoration: adm.component-token($name, 'text-decoration-focus');
        }
        &:active {
            background: adm.component-token($name, 'background-active');
            color: adm.component-token($name, 'text-active');
            border: adm.component-token($name, 'border-active');
            outline: adm.component-token($name, 'outline-active');
            text-decoration: adm.component-token($name, 'text-decoration-active');
        }

    }

    :host([disabled]),
    [disabled] {
        opacity: 0.4;
        pointer-events: none;
    }

    // individual code
    @content;

}